unit schRecibosClienteClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_RecibosCliente = '{776FD400-E6B9-4576-9F25-00B597720267}';
  RID_RecibosCliente_Refresh = '{89591B66-A8AE-46A9-AC71-AB0AB81A492F}';
  RID_PagosCliente = '{C68E4866-2A58-4CE5-BBA0-1EDB8646170C}';
  RID_RecibosCompensadosCli = '{B4FBAFB5-6C87-40F3-9BF9-D477D59971DA}';

  { Data table names }
  nme_RecibosCliente = 'RecibosCliente';
  nme_RecibosCliente_Refresh = 'RecibosCliente_Refresh';
  nme_PagosCliente = 'PagosCliente';
  nme_RecibosCompensadosCli = 'RecibosCompensadosCli';

  { RecibosCliente fields }
  fld_RecibosClienteID = 'ID';
  fld_RecibosClienteID_RECIBO_COMPENSADO = 'ID_RECIBO_COMPENSADO';
  fld_RecibosClienteREFERENCIA_REC_COMPENSADO = 'REFERENCIA_REC_COMPENSADO';
  fld_RecibosClienteREFERENCIA = 'REFERENCIA';
  fld_RecibosClienteSITUACION = 'SITUACION';
  fld_RecibosClienteID_FACTURA = 'ID_FACTURA';
  fld_RecibosClienteID_REMESA = 'ID_REMESA';
  fld_RecibosClienteREFERENCIA_REMESA = 'REFERENCIA_REMESA';
  fld_RecibosClienteFECHA_EMISION = 'FECHA_EMISION';
  fld_RecibosClienteFECHA_VENCIMIENTO = 'FECHA_VENCIMIENTO';
  fld_RecibosClienteDESCRIPCION = 'DESCRIPCION';
  fld_RecibosClienteOBSERVACIONES = 'OBSERVACIONES';
  fld_RecibosClienteIMPORTE = 'IMPORTE';
  fld_RecibosClienteOTROS_GASTOS = 'OTROS_GASTOS';
  fld_RecibosClienteIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_RecibosClienteFECHA_FACTURA = 'FECHA_FACTURA';
  fld_RecibosClienteFORMA_PAGO_FACTURA = 'FORMA_PAGO_FACTURA';
  fld_RecibosClienteIMPORTE_FACTURA = 'IMPORTE_FACTURA';
  fld_RecibosClienteID_CLIENTE = 'ID_CLIENTE';
  fld_RecibosClienteNOMBRE_CLIENTE = 'NOMBRE_CLIENTE';
  fld_RecibosClienteNIF_CIF_CLIENTE = 'NIF_CIF_CLIENTE';
  fld_RecibosClienteENTIDAD_CLIENTE = 'ENTIDAD_CLIENTE';
  fld_RecibosClienteSUCURSAL_CLIENTE = 'SUCURSAL_CLIENTE';
  fld_RecibosClienteDC_CLIENTE = 'DC_CLIENTE';
  fld_RecibosClienteCUENTA_CLIENTE = 'CUENTA_CLIENTE';
  fld_RecibosClienteID_EMPRESA = 'ID_EMPRESA';
  fld_RecibosClienteFECHA_ALTA = 'FECHA_ALTA';
  fld_RecibosClienteFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_RecibosClienteUSUARIO = 'USUARIO';

  { RecibosCliente field indexes }
  idx_RecibosClienteID = 0;
  idx_RecibosClienteID_RECIBO_COMPENSADO = 1;
  idx_RecibosClienteREFERENCIA_REC_COMPENSADO = 2;
  idx_RecibosClienteREFERENCIA = 3;
  idx_RecibosClienteSITUACION = 4;
  idx_RecibosClienteID_FACTURA = 5;
  idx_RecibosClienteID_REMESA = 6;
  idx_RecibosClienteREFERENCIA_REMESA = 7;
  idx_RecibosClienteFECHA_EMISION = 8;
  idx_RecibosClienteFECHA_VENCIMIENTO = 9;
  idx_RecibosClienteDESCRIPCION = 10;
  idx_RecibosClienteOBSERVACIONES = 11;
  idx_RecibosClienteIMPORTE = 12;
  idx_RecibosClienteOTROS_GASTOS = 13;
  idx_RecibosClienteIMPORTE_TOTAL = 14;
  idx_RecibosClienteFECHA_FACTURA = 15;
  idx_RecibosClienteFORMA_PAGO_FACTURA = 16;
  idx_RecibosClienteIMPORTE_FACTURA = 17;
  idx_RecibosClienteID_CLIENTE = 18;
  idx_RecibosClienteNOMBRE_CLIENTE = 19;
  idx_RecibosClienteNIF_CIF_CLIENTE = 20;
  idx_RecibosClienteENTIDAD_CLIENTE = 21;
  idx_RecibosClienteSUCURSAL_CLIENTE = 22;
  idx_RecibosClienteDC_CLIENTE = 23;
  idx_RecibosClienteCUENTA_CLIENTE = 24;
  idx_RecibosClienteID_EMPRESA = 25;
  idx_RecibosClienteFECHA_ALTA = 26;
  idx_RecibosClienteFECHA_MODIFICACION = 27;
  idx_RecibosClienteUSUARIO = 28;

  { RecibosCliente_Refresh fields }
  fld_RecibosCliente_RefreshID = 'ID';
  fld_RecibosCliente_RefreshID_RECIBO_COMPENSADO = 'ID_RECIBO_COMPENSADO';
  fld_RecibosCliente_RefreshREFERENCIA_REC_COMPENSADO = 'REFERENCIA_REC_COMPENSADO';
  fld_RecibosCliente_RefreshREFERENCIA = 'REFERENCIA';
  fld_RecibosCliente_RefreshSITUACION = 'SITUACION';
  fld_RecibosCliente_RefreshID_FACTURA = 'ID_FACTURA';
  fld_RecibosCliente_RefreshID_REMESA = 'ID_REMESA';
  fld_RecibosCliente_RefreshREFERENCIA_REMESA = 'REFERENCIA_REMESA';
  fld_RecibosCliente_RefreshFECHA_EMISION = 'FECHA_EMISION';
  fld_RecibosCliente_RefreshFECHA_VENCIMIENTO = 'FECHA_VENCIMIENTO';
  fld_RecibosCliente_RefreshDESCRIPCION = 'DESCRIPCION';
  fld_RecibosCliente_RefreshOBSERVACIONES = 'OBSERVACIONES';
  fld_RecibosCliente_RefreshIMPORTE = 'IMPORTE';
  fld_RecibosCliente_RefreshOTROS_GASTOS = 'OTROS_GASTOS';
  fld_RecibosCliente_RefreshIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_RecibosCliente_RefreshFECHA_FACTURA = 'FECHA_FACTURA';
  fld_RecibosCliente_RefreshFORMA_PAGO_FACTURA = 'FORMA_PAGO_FACTURA';
  fld_RecibosCliente_RefreshIMPORTE_FACTURA = 'IMPORTE_FACTURA';
  fld_RecibosCliente_RefreshID_CLIENTE = 'ID_CLIENTE';
  fld_RecibosCliente_RefreshNOMBRE_CLIENTE = 'NOMBRE_CLIENTE';
  fld_RecibosCliente_RefreshNIF_CIF_CLIENTE = 'NIF_CIF_CLIENTE';
  fld_RecibosCliente_RefreshENTIDAD_CLIENTE = 'ENTIDAD_CLIENTE';
  fld_RecibosCliente_RefreshSUCURSAL_CLIENTE = 'SUCURSAL_CLIENTE';
  fld_RecibosCliente_RefreshDC_CLIENTE = 'DC_CLIENTE';
  fld_RecibosCliente_RefreshCUENTA_CLIENTE = 'CUENTA_CLIENTE';
  fld_RecibosCliente_RefreshID_EMPRESA = 'ID_EMPRESA';
  fld_RecibosCliente_RefreshFECHA_ALTA = 'FECHA_ALTA';
  fld_RecibosCliente_RefreshFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_RecibosCliente_RefreshUSUARIO = 'USUARIO';

  { RecibosCliente_Refresh field indexes }
  idx_RecibosCliente_RefreshID = 0;
  idx_RecibosCliente_RefreshID_RECIBO_COMPENSADO = 1;
  idx_RecibosCliente_RefreshREFERENCIA_REC_COMPENSADO = 2;
  idx_RecibosCliente_RefreshREFERENCIA = 3;
  idx_RecibosCliente_RefreshSITUACION = 4;
  idx_RecibosCliente_RefreshID_FACTURA = 5;
  idx_RecibosCliente_RefreshID_REMESA = 6;
  idx_RecibosCliente_RefreshREFERENCIA_REMESA = 7;
  idx_RecibosCliente_RefreshFECHA_EMISION = 8;
  idx_RecibosCliente_RefreshFECHA_VENCIMIENTO = 9;
  idx_RecibosCliente_RefreshDESCRIPCION = 10;
  idx_RecibosCliente_RefreshOBSERVACIONES = 11;
  idx_RecibosCliente_RefreshIMPORTE = 12;
  idx_RecibosCliente_RefreshOTROS_GASTOS = 13;
  idx_RecibosCliente_RefreshIMPORTE_TOTAL = 14;
  idx_RecibosCliente_RefreshFECHA_FACTURA = 15;
  idx_RecibosCliente_RefreshFORMA_PAGO_FACTURA = 16;
  idx_RecibosCliente_RefreshIMPORTE_FACTURA = 17;
  idx_RecibosCliente_RefreshID_CLIENTE = 18;
  idx_RecibosCliente_RefreshNOMBRE_CLIENTE = 19;
  idx_RecibosCliente_RefreshNIF_CIF_CLIENTE = 20;
  idx_RecibosCliente_RefreshENTIDAD_CLIENTE = 21;
  idx_RecibosCliente_RefreshSUCURSAL_CLIENTE = 22;
  idx_RecibosCliente_RefreshDC_CLIENTE = 23;
  idx_RecibosCliente_RefreshCUENTA_CLIENTE = 24;
  idx_RecibosCliente_RefreshID_EMPRESA = 25;
  idx_RecibosCliente_RefreshFECHA_ALTA = 26;
  idx_RecibosCliente_RefreshFECHA_MODIFICACION = 27;
  idx_RecibosCliente_RefreshUSUARIO = 28;

  { PagosCliente fields }
  fld_PagosClienteID = 'ID';
  fld_PagosClienteID_RECIBO = 'ID_RECIBO';
  fld_PagosClienteTIPO = 'TIPO';
  fld_PagosClienteFECHA_PAGO = 'FECHA_PAGO';
  fld_PagosClienteTITULAR = 'TITULAR';
  fld_PagosClienteENTIDAD = 'ENTIDAD';
  fld_PagosClienteSUCURSAL = 'SUCURSAL';
  fld_PagosClienteDC = 'DC';
  fld_PagosClienteCUENTA = 'CUENTA';
  fld_PagosClienteFECHA_ALTA = 'FECHA_ALTA';
  fld_PagosClienteFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_PagosClienteUSUARIO = 'USUARIO';

  { PagosCliente field indexes }
  idx_PagosClienteID = 0;
  idx_PagosClienteID_RECIBO = 1;
  idx_PagosClienteTIPO = 2;
  idx_PagosClienteFECHA_PAGO = 3;
  idx_PagosClienteTITULAR = 4;
  idx_PagosClienteENTIDAD = 5;
  idx_PagosClienteSUCURSAL = 6;
  idx_PagosClienteDC = 7;
  idx_PagosClienteCUENTA = 8;
  idx_PagosClienteFECHA_ALTA = 9;
  idx_PagosClienteFECHA_MODIFICACION = 10;
  idx_PagosClienteUSUARIO = 11;

  { RecibosCompensadosCli fields }
  fld_RecibosCompensadosCliID = 'ID';
  fld_RecibosCompensadosCliID_RECIBO_COMPENSADO = 'ID_RECIBO_COMPENSADO';
  fld_RecibosCompensadosCliREFERENCIA = 'REFERENCIA';
  fld_RecibosCompensadosCliSITUACION = 'SITUACION';
  fld_RecibosCompensadosCliID_FACTURA = 'ID_FACTURA';
  fld_RecibosCompensadosCliFECHA_EMISION = 'FECHA_EMISION';
  fld_RecibosCompensadosCliFECHA_VENCIMIENTO = 'FECHA_VENCIMIENTO';
  fld_RecibosCompensadosCliIMPORTE = 'IMPORTE';
  fld_RecibosCompensadosCliOTROS_GASTOS = 'OTROS_GASTOS';
  fld_RecibosCompensadosCliIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_RecibosCompensadosCliFECHA_FACTURA = 'FECHA_FACTURA';
  fld_RecibosCompensadosCliIMPORTE_FACTURA = 'IMPORTE_FACTURA';
  fld_RecibosCompensadosCliID_CLIENTE = 'ID_CLIENTE';
  fld_RecibosCompensadosCliNOMBRE_CLIENTE = 'NOMBRE_CLIENTE';
  fld_RecibosCompensadosCliNIF_CIF_CLIENTE = 'NIF_CIF_CLIENTE';
  fld_RecibosCompensadosCliID_EMPRESA = 'ID_EMPRESA';

  { RecibosCompensadosCli field indexes }
  idx_RecibosCompensadosCliID = 0;
  idx_RecibosCompensadosCliID_RECIBO_COMPENSADO = 1;
  idx_RecibosCompensadosCliREFERENCIA = 2;
  idx_RecibosCompensadosCliSITUACION = 3;
  idx_RecibosCompensadosCliID_FACTURA = 4;
  idx_RecibosCompensadosCliFECHA_EMISION = 5;
  idx_RecibosCompensadosCliFECHA_VENCIMIENTO = 6;
  idx_RecibosCompensadosCliIMPORTE = 7;
  idx_RecibosCompensadosCliOTROS_GASTOS = 8;
  idx_RecibosCompensadosCliIMPORTE_TOTAL = 9;
  idx_RecibosCompensadosCliFECHA_FACTURA = 10;
  idx_RecibosCompensadosCliIMPORTE_FACTURA = 11;
  idx_RecibosCompensadosCliID_CLIENTE = 12;
  idx_RecibosCompensadosCliNOMBRE_CLIENTE = 13;
  idx_RecibosCompensadosCliNIF_CIF_CLIENTE = 14;
  idx_RecibosCompensadosCliID_EMPRESA = 15;

type
  { IRecibosCliente }
  IRecibosCliente = interface(IDAStronglyTypedDataTable)
  ['{C690E544-36BE-450C-8CA2-C453C7D6A23D}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_RECIBO_COMPENSADOValue: Integer;
    procedure SetID_RECIBO_COMPENSADOValue(const aValue: Integer);
    function GetREFERENCIA_REC_COMPENSADOValue: String;
    procedure SetREFERENCIA_REC_COMPENSADOValue(const aValue: String);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetID_REMESAValue: Integer;
    procedure SetID_REMESAValue(const aValue: Integer);
    function GetREFERENCIA_REMESAValue: String;
    procedure SetREFERENCIA_REMESAValue(const aValue: String);
    function GetFECHA_EMISIONValue: DateTime;
    procedure SetFECHA_EMISIONValue(const aValue: DateTime);
    function GetFECHA_VENCIMIENTOValue: DateTime;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetOBSERVACIONESValue: String;
    procedure SetOBSERVACIONESValue(const aValue: String);
    function GetIMPORTEValue: Currency;
    procedure SetIMPORTEValue(const aValue: Currency);
    function GetOTROS_GASTOSValue: Currency;
    procedure SetOTROS_GASTOSValue(const aValue: Currency);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetFORMA_PAGO_FACTURAValue: String;
    procedure SetFORMA_PAGO_FACTURAValue(const aValue: String);
    function GetIMPORTE_FACTURAValue: Currency;
    procedure SetIMPORTE_FACTURAValue(const aValue: Currency);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetNOMBRE_CLIENTEValue: String;
    procedure SetNOMBRE_CLIENTEValue(const aValue: String);
    function GetNIF_CIF_CLIENTEValue: String;
    procedure SetNIF_CIF_CLIENTEValue(const aValue: String);
    function GetENTIDAD_CLIENTEValue: String;
    procedure SetENTIDAD_CLIENTEValue(const aValue: String);
    function GetSUCURSAL_CLIENTEValue: String;
    procedure SetSUCURSAL_CLIENTEValue(const aValue: String);
    function GetDC_CLIENTEValue: String;
    procedure SetDC_CLIENTEValue(const aValue: String);
    function GetCUENTA_CLIENTEValue: String;
    procedure SetCUENTA_CLIENTEValue(const aValue: String);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_RECIBO_COMPENSADO: Integer read GetID_RECIBO_COMPENSADOValue write SetID_RECIBO_COMPENSADOValue;
    property REFERENCIA_REC_COMPENSADO: String read GetREFERENCIA_REC_COMPENSADOValue write SetREFERENCIA_REC_COMPENSADOValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_REMESA: Integer read GetID_REMESAValue write SetID_REMESAValue;
    property REFERENCIA_REMESA: String read GetREFERENCIA_REMESAValue write SetREFERENCIA_REMESAValue;
    property FECHA_EMISION: DateTime read GetFECHA_EMISIONValue write SetFECHA_EMISIONValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OBSERVACIONES: String read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property IMPORTE: Currency read GetIMPORTEValue write SetIMPORTEValue;
    property OTROS_GASTOS: Currency read GetOTROS_GASTOSValue write SetOTROS_GASTOSValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property FORMA_PAGO_FACTURA: String read GetFORMA_PAGO_FACTURAValue write SetFORMA_PAGO_FACTURAValue;
    property IMPORTE_FACTURA: Currency read GetIMPORTE_FACTURAValue write SetIMPORTE_FACTURAValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NOMBRE_CLIENTE: String read GetNOMBRE_CLIENTEValue write SetNOMBRE_CLIENTEValue;
    property NIF_CIF_CLIENTE: String read GetNIF_CIF_CLIENTEValue write SetNIF_CIF_CLIENTEValue;
    property ENTIDAD_CLIENTE: String read GetENTIDAD_CLIENTEValue write SetENTIDAD_CLIENTEValue;
    property SUCURSAL_CLIENTE: String read GetSUCURSAL_CLIENTEValue write SetSUCURSAL_CLIENTEValue;
    property DC_CLIENTE: String read GetDC_CLIENTEValue write SetDC_CLIENTEValue;
    property CUENTA_CLIENTE: String read GetCUENTA_CLIENTEValue write SetCUENTA_CLIENTEValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
  end;

  { TRecibosClienteDataTableRules }
  TRecibosClienteDataTableRules = class(TDADataTableRules, IRecibosCliente)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_RECIBO_COMPENSADOValue: Integer; virtual;
    procedure SetID_RECIBO_COMPENSADOValue(const aValue: Integer); virtual;
    function GetREFERENCIA_REC_COMPENSADOValue: String; virtual;
    procedure SetREFERENCIA_REC_COMPENSADOValue(const aValue: String); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetID_REMESAValue: Integer; virtual;
    procedure SetID_REMESAValue(const aValue: Integer); virtual;
    function GetREFERENCIA_REMESAValue: String; virtual;
    procedure SetREFERENCIA_REMESAValue(const aValue: String); virtual;
    function GetFECHA_EMISIONValue: DateTime; virtual;
    procedure SetFECHA_EMISIONValue(const aValue: DateTime); virtual;
    function GetFECHA_VENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetOBSERVACIONESValue: String; virtual;
    procedure SetOBSERVACIONESValue(const aValue: String); virtual;
    function GetIMPORTEValue: Currency; virtual;
    procedure SetIMPORTEValue(const aValue: Currency); virtual;
    function GetOTROS_GASTOSValue: Currency; virtual;
    procedure SetOTROS_GASTOSValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetFORMA_PAGO_FACTURAValue: String; virtual;
    procedure SetFORMA_PAGO_FACTURAValue(const aValue: String); virtual;
    function GetIMPORTE_FACTURAValue: Currency; virtual;
    procedure SetIMPORTE_FACTURAValue(const aValue: Currency); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetNOMBRE_CLIENTEValue: String; virtual;
    procedure SetNOMBRE_CLIENTEValue(const aValue: String); virtual;
    function GetNIF_CIF_CLIENTEValue: String; virtual;
    procedure SetNIF_CIF_CLIENTEValue(const aValue: String); virtual;
    function GetENTIDAD_CLIENTEValue: String; virtual;
    procedure SetENTIDAD_CLIENTEValue(const aValue: String); virtual;
    function GetSUCURSAL_CLIENTEValue: String; virtual;
    procedure SetSUCURSAL_CLIENTEValue(const aValue: String); virtual;
    function GetDC_CLIENTEValue: String; virtual;
    procedure SetDC_CLIENTEValue(const aValue: String); virtual;
    function GetCUENTA_CLIENTEValue: String; virtual;
    procedure SetCUENTA_CLIENTEValue(const aValue: String); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_RECIBO_COMPENSADO: Integer read GetID_RECIBO_COMPENSADOValue write SetID_RECIBO_COMPENSADOValue;
    property REFERENCIA_REC_COMPENSADO: String read GetREFERENCIA_REC_COMPENSADOValue write SetREFERENCIA_REC_COMPENSADOValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_REMESA: Integer read GetID_REMESAValue write SetID_REMESAValue;
    property REFERENCIA_REMESA: String read GetREFERENCIA_REMESAValue write SetREFERENCIA_REMESAValue;
    property FECHA_EMISION: DateTime read GetFECHA_EMISIONValue write SetFECHA_EMISIONValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OBSERVACIONES: String read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property IMPORTE: Currency read GetIMPORTEValue write SetIMPORTEValue;
    property OTROS_GASTOS: Currency read GetOTROS_GASTOSValue write SetOTROS_GASTOSValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property FORMA_PAGO_FACTURA: String read GetFORMA_PAGO_FACTURAValue write SetFORMA_PAGO_FACTURAValue;
    property IMPORTE_FACTURA: Currency read GetIMPORTE_FACTURAValue write SetIMPORTE_FACTURAValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NOMBRE_CLIENTE: String read GetNOMBRE_CLIENTEValue write SetNOMBRE_CLIENTEValue;
    property NIF_CIF_CLIENTE: String read GetNIF_CIF_CLIENTEValue write SetNIF_CIF_CLIENTEValue;
    property ENTIDAD_CLIENTE: String read GetENTIDAD_CLIENTEValue write SetENTIDAD_CLIENTEValue;
    property SUCURSAL_CLIENTE: String read GetSUCURSAL_CLIENTEValue write SetSUCURSAL_CLIENTEValue;
    property DC_CLIENTE: String read GetDC_CLIENTEValue write SetDC_CLIENTEValue;
    property CUENTA_CLIENTE: String read GetCUENTA_CLIENTEValue write SetCUENTA_CLIENTEValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IRecibosCliente_Refresh }
  IRecibosCliente_Refresh = interface(IDAStronglyTypedDataTable)
  ['{989F96EE-C6AE-403E-9A56-B01C4716E6B6}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_RECIBO_COMPENSADOValue: Integer;
    procedure SetID_RECIBO_COMPENSADOValue(const aValue: Integer);
    function GetREFERENCIA_REC_COMPENSADOValue: String;
    procedure SetREFERENCIA_REC_COMPENSADOValue(const aValue: String);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetID_REMESAValue: Integer;
    procedure SetID_REMESAValue(const aValue: Integer);
    function GetREFERENCIA_REMESAValue: String;
    procedure SetREFERENCIA_REMESAValue(const aValue: String);
    function GetFECHA_EMISIONValue: DateTime;
    procedure SetFECHA_EMISIONValue(const aValue: DateTime);
    function GetFECHA_VENCIMIENTOValue: DateTime;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetOBSERVACIONESValue: String;
    procedure SetOBSERVACIONESValue(const aValue: String);
    function GetIMPORTEValue: Currency;
    procedure SetIMPORTEValue(const aValue: Currency);
    function GetOTROS_GASTOSValue: Currency;
    procedure SetOTROS_GASTOSValue(const aValue: Currency);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetFORMA_PAGO_FACTURAValue: String;
    procedure SetFORMA_PAGO_FACTURAValue(const aValue: String);
    function GetIMPORTE_FACTURAValue: Currency;
    procedure SetIMPORTE_FACTURAValue(const aValue: Currency);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetNOMBRE_CLIENTEValue: String;
    procedure SetNOMBRE_CLIENTEValue(const aValue: String);
    function GetNIF_CIF_CLIENTEValue: String;
    procedure SetNIF_CIF_CLIENTEValue(const aValue: String);
    function GetENTIDAD_CLIENTEValue: String;
    procedure SetENTIDAD_CLIENTEValue(const aValue: String);
    function GetSUCURSAL_CLIENTEValue: String;
    procedure SetSUCURSAL_CLIENTEValue(const aValue: String);
    function GetDC_CLIENTEValue: String;
    procedure SetDC_CLIENTEValue(const aValue: String);
    function GetCUENTA_CLIENTEValue: String;
    procedure SetCUENTA_CLIENTEValue(const aValue: String);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_RECIBO_COMPENSADO: Integer read GetID_RECIBO_COMPENSADOValue write SetID_RECIBO_COMPENSADOValue;
    property REFERENCIA_REC_COMPENSADO: String read GetREFERENCIA_REC_COMPENSADOValue write SetREFERENCIA_REC_COMPENSADOValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_REMESA: Integer read GetID_REMESAValue write SetID_REMESAValue;
    property REFERENCIA_REMESA: String read GetREFERENCIA_REMESAValue write SetREFERENCIA_REMESAValue;
    property FECHA_EMISION: DateTime read GetFECHA_EMISIONValue write SetFECHA_EMISIONValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OBSERVACIONES: String read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property IMPORTE: Currency read GetIMPORTEValue write SetIMPORTEValue;
    property OTROS_GASTOS: Currency read GetOTROS_GASTOSValue write SetOTROS_GASTOSValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property FORMA_PAGO_FACTURA: String read GetFORMA_PAGO_FACTURAValue write SetFORMA_PAGO_FACTURAValue;
    property IMPORTE_FACTURA: Currency read GetIMPORTE_FACTURAValue write SetIMPORTE_FACTURAValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NOMBRE_CLIENTE: String read GetNOMBRE_CLIENTEValue write SetNOMBRE_CLIENTEValue;
    property NIF_CIF_CLIENTE: String read GetNIF_CIF_CLIENTEValue write SetNIF_CIF_CLIENTEValue;
    property ENTIDAD_CLIENTE: String read GetENTIDAD_CLIENTEValue write SetENTIDAD_CLIENTEValue;
    property SUCURSAL_CLIENTE: String read GetSUCURSAL_CLIENTEValue write SetSUCURSAL_CLIENTEValue;
    property DC_CLIENTE: String read GetDC_CLIENTEValue write SetDC_CLIENTEValue;
    property CUENTA_CLIENTE: String read GetCUENTA_CLIENTEValue write SetCUENTA_CLIENTEValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
  end;

  { TRecibosCliente_RefreshDataTableRules }
  TRecibosCliente_RefreshDataTableRules = class(TDADataTableRules, IRecibosCliente_Refresh)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_RECIBO_COMPENSADOValue: Integer; virtual;
    procedure SetID_RECIBO_COMPENSADOValue(const aValue: Integer); virtual;
    function GetREFERENCIA_REC_COMPENSADOValue: String; virtual;
    procedure SetREFERENCIA_REC_COMPENSADOValue(const aValue: String); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetID_REMESAValue: Integer; virtual;
    procedure SetID_REMESAValue(const aValue: Integer); virtual;
    function GetREFERENCIA_REMESAValue: String; virtual;
    procedure SetREFERENCIA_REMESAValue(const aValue: String); virtual;
    function GetFECHA_EMISIONValue: DateTime; virtual;
    procedure SetFECHA_EMISIONValue(const aValue: DateTime); virtual;
    function GetFECHA_VENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetOBSERVACIONESValue: String; virtual;
    procedure SetOBSERVACIONESValue(const aValue: String); virtual;
    function GetIMPORTEValue: Currency; virtual;
    procedure SetIMPORTEValue(const aValue: Currency); virtual;
    function GetOTROS_GASTOSValue: Currency; virtual;
    procedure SetOTROS_GASTOSValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetFORMA_PAGO_FACTURAValue: String; virtual;
    procedure SetFORMA_PAGO_FACTURAValue(const aValue: String); virtual;
    function GetIMPORTE_FACTURAValue: Currency; virtual;
    procedure SetIMPORTE_FACTURAValue(const aValue: Currency); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetNOMBRE_CLIENTEValue: String; virtual;
    procedure SetNOMBRE_CLIENTEValue(const aValue: String); virtual;
    function GetNIF_CIF_CLIENTEValue: String; virtual;
    procedure SetNIF_CIF_CLIENTEValue(const aValue: String); virtual;
    function GetENTIDAD_CLIENTEValue: String; virtual;
    procedure SetENTIDAD_CLIENTEValue(const aValue: String); virtual;
    function GetSUCURSAL_CLIENTEValue: String; virtual;
    procedure SetSUCURSAL_CLIENTEValue(const aValue: String); virtual;
    function GetDC_CLIENTEValue: String; virtual;
    procedure SetDC_CLIENTEValue(const aValue: String); virtual;
    function GetCUENTA_CLIENTEValue: String; virtual;
    procedure SetCUENTA_CLIENTEValue(const aValue: String); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_RECIBO_COMPENSADO: Integer read GetID_RECIBO_COMPENSADOValue write SetID_RECIBO_COMPENSADOValue;
    property REFERENCIA_REC_COMPENSADO: String read GetREFERENCIA_REC_COMPENSADOValue write SetREFERENCIA_REC_COMPENSADOValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_REMESA: Integer read GetID_REMESAValue write SetID_REMESAValue;
    property REFERENCIA_REMESA: String read GetREFERENCIA_REMESAValue write SetREFERENCIA_REMESAValue;
    property FECHA_EMISION: DateTime read GetFECHA_EMISIONValue write SetFECHA_EMISIONValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OBSERVACIONES: String read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property IMPORTE: Currency read GetIMPORTEValue write SetIMPORTEValue;
    property OTROS_GASTOS: Currency read GetOTROS_GASTOSValue write SetOTROS_GASTOSValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property FORMA_PAGO_FACTURA: String read GetFORMA_PAGO_FACTURAValue write SetFORMA_PAGO_FACTURAValue;
    property IMPORTE_FACTURA: Currency read GetIMPORTE_FACTURAValue write SetIMPORTE_FACTURAValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NOMBRE_CLIENTE: String read GetNOMBRE_CLIENTEValue write SetNOMBRE_CLIENTEValue;
    property NIF_CIF_CLIENTE: String read GetNIF_CIF_CLIENTEValue write SetNIF_CIF_CLIENTEValue;
    property ENTIDAD_CLIENTE: String read GetENTIDAD_CLIENTEValue write SetENTIDAD_CLIENTEValue;
    property SUCURSAL_CLIENTE: String read GetSUCURSAL_CLIENTEValue write SetSUCURSAL_CLIENTEValue;
    property DC_CLIENTE: String read GetDC_CLIENTEValue write SetDC_CLIENTEValue;
    property CUENTA_CLIENTE: String read GetCUENTA_CLIENTEValue write SetCUENTA_CLIENTEValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IPagosCliente }
  IPagosCliente = interface(IDAStronglyTypedDataTable)
  ['{50466FF1-7C4F-4294-98B1-39DC7589D8A8}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_RECIBOValue: Integer;
    procedure SetID_RECIBOValue(const aValue: Integer);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);
    function GetFECHA_PAGOValue: DateTime;
    procedure SetFECHA_PAGOValue(const aValue: DateTime);
    function GetTITULARValue: String;
    procedure SetTITULARValue(const aValue: String);
    function GetENTIDADValue: String;
    procedure SetENTIDADValue(const aValue: String);
    function GetSUCURSALValue: String;
    procedure SetSUCURSALValue(const aValue: String);
    function GetDCValue: String;
    procedure SetDCValue(const aValue: String);
    function GetCUENTAValue: String;
    procedure SetCUENTAValue(const aValue: String);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_RECIBO: Integer read GetID_RECIBOValue write SetID_RECIBOValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property FECHA_PAGO: DateTime read GetFECHA_PAGOValue write SetFECHA_PAGOValue;
    property TITULAR: String read GetTITULARValue write SetTITULARValue;
    property ENTIDAD: String read GetENTIDADValue write SetENTIDADValue;
    property SUCURSAL: String read GetSUCURSALValue write SetSUCURSALValue;
    property DC: String read GetDCValue write SetDCValue;
    property CUENTA: String read GetCUENTAValue write SetCUENTAValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
  end;

  { TPagosClienteDataTableRules }
  TPagosClienteDataTableRules = class(TDADataTableRules, IPagosCliente)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_RECIBOValue: Integer; virtual;
    procedure SetID_RECIBOValue(const aValue: Integer); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetFECHA_PAGOValue: DateTime; virtual;
    procedure SetFECHA_PAGOValue(const aValue: DateTime); virtual;
    function GetTITULARValue: String; virtual;
    procedure SetTITULARValue(const aValue: String); virtual;
    function GetENTIDADValue: String; virtual;
    procedure SetENTIDADValue(const aValue: String); virtual;
    function GetSUCURSALValue: String; virtual;
    procedure SetSUCURSALValue(const aValue: String); virtual;
    function GetDCValue: String; virtual;
    procedure SetDCValue(const aValue: String); virtual;
    function GetCUENTAValue: String; virtual;
    procedure SetCUENTAValue(const aValue: String); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_RECIBO: Integer read GetID_RECIBOValue write SetID_RECIBOValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property FECHA_PAGO: DateTime read GetFECHA_PAGOValue write SetFECHA_PAGOValue;
    property TITULAR: String read GetTITULARValue write SetTITULARValue;
    property ENTIDAD: String read GetENTIDADValue write SetENTIDADValue;
    property SUCURSAL: String read GetSUCURSALValue write SetSUCURSALValue;
    property DC: String read GetDCValue write SetDCValue;
    property CUENTA: String read GetCUENTAValue write SetCUENTAValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IRecibosCompensadosCli }
  IRecibosCompensadosCli = interface(IDAStronglyTypedDataTable)
  ['{D2E38DD6-E307-40E0-8B4A-C72B9F8D86D0}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_RECIBO_COMPENSADOValue: Integer;
    procedure SetID_RECIBO_COMPENSADOValue(const aValue: Integer);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetFECHA_EMISIONValue: DateTime;
    procedure SetFECHA_EMISIONValue(const aValue: DateTime);
    function GetFECHA_VENCIMIENTOValue: DateTime;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
    function GetIMPORTEValue: Currency;
    procedure SetIMPORTEValue(const aValue: Currency);
    function GetOTROS_GASTOSValue: Currency;
    procedure SetOTROS_GASTOSValue(const aValue: Currency);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetIMPORTE_FACTURAValue: Currency;
    procedure SetIMPORTE_FACTURAValue(const aValue: Currency);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetNOMBRE_CLIENTEValue: String;
    procedure SetNOMBRE_CLIENTEValue(const aValue: String);
    function GetNIF_CIF_CLIENTEValue: String;
    procedure SetNIF_CIF_CLIENTEValue(const aValue: String);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_RECIBO_COMPENSADO: Integer read GetID_RECIBO_COMPENSADOValue write SetID_RECIBO_COMPENSADOValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property FECHA_EMISION: DateTime read GetFECHA_EMISIONValue write SetFECHA_EMISIONValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
    property IMPORTE: Currency read GetIMPORTEValue write SetIMPORTEValue;
    property OTROS_GASTOS: Currency read GetOTROS_GASTOSValue write SetOTROS_GASTOSValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property IMPORTE_FACTURA: Currency read GetIMPORTE_FACTURAValue write SetIMPORTE_FACTURAValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NOMBRE_CLIENTE: String read GetNOMBRE_CLIENTEValue write SetNOMBRE_CLIENTEValue;
    property NIF_CIF_CLIENTE: String read GetNIF_CIF_CLIENTEValue write SetNIF_CIF_CLIENTEValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
  end;

  { TRecibosCompensadosCliDataTableRules }
  TRecibosCompensadosCliDataTableRules = class(TDADataTableRules, IRecibosCompensadosCli)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_RECIBO_COMPENSADOValue: Integer; virtual;
    procedure SetID_RECIBO_COMPENSADOValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetFECHA_EMISIONValue: DateTime; virtual;
    procedure SetFECHA_EMISIONValue(const aValue: DateTime); virtual;
    function GetFECHA_VENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime); virtual;
    function GetIMPORTEValue: Currency; virtual;
    procedure SetIMPORTEValue(const aValue: Currency); virtual;
    function GetOTROS_GASTOSValue: Currency; virtual;
    procedure SetOTROS_GASTOSValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetIMPORTE_FACTURAValue: Currency; virtual;
    procedure SetIMPORTE_FACTURAValue(const aValue: Currency); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetNOMBRE_CLIENTEValue: String; virtual;
    procedure SetNOMBRE_CLIENTEValue(const aValue: String); virtual;
    function GetNIF_CIF_CLIENTEValue: String; virtual;
    procedure SetNIF_CIF_CLIENTEValue(const aValue: String); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_RECIBO_COMPENSADO: Integer read GetID_RECIBO_COMPENSADOValue write SetID_RECIBO_COMPENSADOValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property FECHA_EMISION: DateTime read GetFECHA_EMISIONValue write SetFECHA_EMISIONValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
    property IMPORTE: Currency read GetIMPORTEValue write SetIMPORTEValue;
    property OTROS_GASTOS: Currency read GetOTROS_GASTOSValue write SetOTROS_GASTOSValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property IMPORTE_FACTURA: Currency read GetIMPORTE_FACTURAValue write SetIMPORTE_FACTURAValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NOMBRE_CLIENTE: String read GetNOMBRE_CLIENTEValue write SetNOMBRE_CLIENTEValue;
    property NIF_CIF_CLIENTE: String read GetNIF_CIF_CLIENTEValue write SetNIF_CIF_CLIENTEValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TRecibosClienteDataTableRules }
constructor TRecibosClienteDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TRecibosClienteDataTableRules.Destroy;
begin
  inherited;
end;

function TRecibosClienteDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosClienteID].AsInteger;
end;

procedure TRecibosClienteDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosClienteID].AsInteger := aValue;
end;

function TRecibosClienteDataTableRules.GetID_RECIBO_COMPENSADOValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosClienteID_RECIBO_COMPENSADO].AsInteger;
end;

procedure TRecibosClienteDataTableRules.SetID_RECIBO_COMPENSADOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosClienteID_RECIBO_COMPENSADO].AsInteger := aValue;
end;

function TRecibosClienteDataTableRules.GetREFERENCIA_REC_COMPENSADOValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteREFERENCIA_REC_COMPENSADO].AsString;
end;

procedure TRecibosClienteDataTableRules.SetREFERENCIA_REC_COMPENSADOValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteREFERENCIA_REC_COMPENSADO].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteREFERENCIA].AsString;
end;

procedure TRecibosClienteDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteREFERENCIA].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteSITUACION].AsString;
end;

procedure TRecibosClienteDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteSITUACION].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosClienteID_FACTURA].AsInteger;
end;

procedure TRecibosClienteDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosClienteID_FACTURA].AsInteger := aValue;
end;

function TRecibosClienteDataTableRules.GetID_REMESAValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosClienteID_REMESA].AsInteger;
end;

procedure TRecibosClienteDataTableRules.SetID_REMESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosClienteID_REMESA].AsInteger := aValue;
end;

function TRecibosClienteDataTableRules.GetREFERENCIA_REMESAValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteREFERENCIA_REMESA].AsString;
end;

procedure TRecibosClienteDataTableRules.SetREFERENCIA_REMESAValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteREFERENCIA_REMESA].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetFECHA_EMISIONValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosClienteFECHA_EMISION].AsDateTime;
end;

procedure TRecibosClienteDataTableRules.SetFECHA_EMISIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosClienteFECHA_EMISION].AsDateTime := aValue;
end;

function TRecibosClienteDataTableRules.GetFECHA_VENCIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosClienteFECHA_VENCIMIENTO].AsDateTime;
end;

procedure TRecibosClienteDataTableRules.SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosClienteFECHA_VENCIMIENTO].AsDateTime := aValue;
end;

function TRecibosClienteDataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteDESCRIPCION].AsString;
end;

procedure TRecibosClienteDataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteDESCRIPCION].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetOBSERVACIONESValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteOBSERVACIONES].AsString;
end;

procedure TRecibosClienteDataTableRules.SetOBSERVACIONESValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteOBSERVACIONES].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetIMPORTEValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosClienteIMPORTE].AsCurrency;
end;

procedure TRecibosClienteDataTableRules.SetIMPORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosClienteIMPORTE].AsCurrency := aValue;
end;

function TRecibosClienteDataTableRules.GetOTROS_GASTOSValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosClienteOTROS_GASTOS].AsCurrency;
end;

procedure TRecibosClienteDataTableRules.SetOTROS_GASTOSValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosClienteOTROS_GASTOS].AsCurrency := aValue;
end;

function TRecibosClienteDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosClienteIMPORTE_TOTAL].AsCurrency;
end;

procedure TRecibosClienteDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosClienteIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TRecibosClienteDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosClienteFECHA_FACTURA].AsDateTime;
end;

procedure TRecibosClienteDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosClienteFECHA_FACTURA].AsDateTime := aValue;
end;

function TRecibosClienteDataTableRules.GetFORMA_PAGO_FACTURAValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteFORMA_PAGO_FACTURA].AsString;
end;

procedure TRecibosClienteDataTableRules.SetFORMA_PAGO_FACTURAValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteFORMA_PAGO_FACTURA].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetIMPORTE_FACTURAValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosClienteIMPORTE_FACTURA].AsCurrency;
end;

procedure TRecibosClienteDataTableRules.SetIMPORTE_FACTURAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosClienteIMPORTE_FACTURA].AsCurrency := aValue;
end;

function TRecibosClienteDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosClienteID_CLIENTE].AsInteger;
end;

procedure TRecibosClienteDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosClienteID_CLIENTE].AsInteger := aValue;
end;

function TRecibosClienteDataTableRules.GetNOMBRE_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteNOMBRE_CLIENTE].AsString;
end;

procedure TRecibosClienteDataTableRules.SetNOMBRE_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteNOMBRE_CLIENTE].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetNIF_CIF_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteNIF_CIF_CLIENTE].AsString;
end;

procedure TRecibosClienteDataTableRules.SetNIF_CIF_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteNIF_CIF_CLIENTE].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetENTIDAD_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteENTIDAD_CLIENTE].AsString;
end;

procedure TRecibosClienteDataTableRules.SetENTIDAD_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteENTIDAD_CLIENTE].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetSUCURSAL_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteSUCURSAL_CLIENTE].AsString;
end;

procedure TRecibosClienteDataTableRules.SetSUCURSAL_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteSUCURSAL_CLIENTE].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetDC_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteDC_CLIENTE].AsString;
end;

procedure TRecibosClienteDataTableRules.SetDC_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteDC_CLIENTE].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetCUENTA_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteCUENTA_CLIENTE].AsString;
end;

procedure TRecibosClienteDataTableRules.SetCUENTA_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteCUENTA_CLIENTE].AsString := aValue;
end;

function TRecibosClienteDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosClienteID_EMPRESA].AsInteger;
end;

procedure TRecibosClienteDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosClienteID_EMPRESA].AsInteger := aValue;
end;

function TRecibosClienteDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosClienteFECHA_ALTA].AsDateTime;
end;

procedure TRecibosClienteDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosClienteFECHA_ALTA].AsDateTime := aValue;
end;

function TRecibosClienteDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosClienteFECHA_MODIFICACION].AsDateTime;
end;

procedure TRecibosClienteDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosClienteFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TRecibosClienteDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_RecibosClienteUSUARIO].AsString;
end;

procedure TRecibosClienteDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosClienteUSUARIO].AsString := aValue;
end;


{ TRecibosCliente_RefreshDataTableRules }
constructor TRecibosCliente_RefreshDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TRecibosCliente_RefreshDataTableRules.Destroy;
begin
  inherited;
end;

function TRecibosCliente_RefreshDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshID].AsInteger;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshID].AsInteger := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetID_RECIBO_COMPENSADOValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshID_RECIBO_COMPENSADO].AsInteger;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetID_RECIBO_COMPENSADOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshID_RECIBO_COMPENSADO].AsInteger := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetREFERENCIA_REC_COMPENSADOValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshREFERENCIA_REC_COMPENSADO].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetREFERENCIA_REC_COMPENSADOValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshREFERENCIA_REC_COMPENSADO].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshREFERENCIA].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshREFERENCIA].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshSITUACION].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshSITUACION].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshID_FACTURA].AsInteger;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshID_FACTURA].AsInteger := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetID_REMESAValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshID_REMESA].AsInteger;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetID_REMESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshID_REMESA].AsInteger := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetREFERENCIA_REMESAValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshREFERENCIA_REMESA].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetREFERENCIA_REMESAValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshREFERENCIA_REMESA].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetFECHA_EMISIONValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshFECHA_EMISION].AsDateTime;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetFECHA_EMISIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshFECHA_EMISION].AsDateTime := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetFECHA_VENCIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshFECHA_VENCIMIENTO].AsDateTime;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshFECHA_VENCIMIENTO].AsDateTime := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshDESCRIPCION].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshDESCRIPCION].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetOBSERVACIONESValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshOBSERVACIONES].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetOBSERVACIONESValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshOBSERVACIONES].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetIMPORTEValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshIMPORTE].AsCurrency;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetIMPORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshIMPORTE].AsCurrency := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetOTROS_GASTOSValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshOTROS_GASTOS].AsCurrency;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetOTROS_GASTOSValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshOTROS_GASTOS].AsCurrency := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshIMPORTE_TOTAL].AsCurrency;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshFECHA_FACTURA].AsDateTime;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshFECHA_FACTURA].AsDateTime := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetFORMA_PAGO_FACTURAValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshFORMA_PAGO_FACTURA].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetFORMA_PAGO_FACTURAValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshFORMA_PAGO_FACTURA].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetIMPORTE_FACTURAValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshIMPORTE_FACTURA].AsCurrency;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetIMPORTE_FACTURAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshIMPORTE_FACTURA].AsCurrency := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshID_CLIENTE].AsInteger;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshID_CLIENTE].AsInteger := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetNOMBRE_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshNOMBRE_CLIENTE].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetNOMBRE_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshNOMBRE_CLIENTE].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetNIF_CIF_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshNIF_CIF_CLIENTE].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetNIF_CIF_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshNIF_CIF_CLIENTE].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetENTIDAD_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshENTIDAD_CLIENTE].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetENTIDAD_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshENTIDAD_CLIENTE].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetSUCURSAL_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshSUCURSAL_CLIENTE].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetSUCURSAL_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshSUCURSAL_CLIENTE].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetDC_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshDC_CLIENTE].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetDC_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshDC_CLIENTE].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetCUENTA_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshCUENTA_CLIENTE].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetCUENTA_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshCUENTA_CLIENTE].AsString := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshID_EMPRESA].AsInteger;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshID_EMPRESA].AsInteger := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshFECHA_ALTA].AsDateTime;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshFECHA_ALTA].AsDateTime := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshFECHA_MODIFICACION].AsDateTime;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TRecibosCliente_RefreshDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_RecibosCliente_RefreshUSUARIO].AsString;
end;

procedure TRecibosCliente_RefreshDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCliente_RefreshUSUARIO].AsString := aValue;
end;


{ TPagosClienteDataTableRules }
constructor TPagosClienteDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TPagosClienteDataTableRules.Destroy;
begin
  inherited;
end;

function TPagosClienteDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_PagosClienteID].AsInteger;
end;

procedure TPagosClienteDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PagosClienteID].AsInteger := aValue;
end;

function TPagosClienteDataTableRules.GetID_RECIBOValue: Integer;
begin
  result := DataTable.Fields[idx_PagosClienteID_RECIBO].AsInteger;
end;

procedure TPagosClienteDataTableRules.SetID_RECIBOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PagosClienteID_RECIBO].AsInteger := aValue;
end;

function TPagosClienteDataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_PagosClienteTIPO].AsString;
end;

procedure TPagosClienteDataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_PagosClienteTIPO].AsString := aValue;
end;

function TPagosClienteDataTableRules.GetFECHA_PAGOValue: DateTime;
begin
  result := DataTable.Fields[idx_PagosClienteFECHA_PAGO].AsDateTime;
end;

procedure TPagosClienteDataTableRules.SetFECHA_PAGOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_PagosClienteFECHA_PAGO].AsDateTime := aValue;
end;

function TPagosClienteDataTableRules.GetTITULARValue: String;
begin
  result := DataTable.Fields[idx_PagosClienteTITULAR].AsString;
end;

procedure TPagosClienteDataTableRules.SetTITULARValue(const aValue: String);
begin
  DataTable.Fields[idx_PagosClienteTITULAR].AsString := aValue;
end;

function TPagosClienteDataTableRules.GetENTIDADValue: String;
begin
  result := DataTable.Fields[idx_PagosClienteENTIDAD].AsString;
end;

procedure TPagosClienteDataTableRules.SetENTIDADValue(const aValue: String);
begin
  DataTable.Fields[idx_PagosClienteENTIDAD].AsString := aValue;
end;

function TPagosClienteDataTableRules.GetSUCURSALValue: String;
begin
  result := DataTable.Fields[idx_PagosClienteSUCURSAL].AsString;
end;

procedure TPagosClienteDataTableRules.SetSUCURSALValue(const aValue: String);
begin
  DataTable.Fields[idx_PagosClienteSUCURSAL].AsString := aValue;
end;

function TPagosClienteDataTableRules.GetDCValue: String;
begin
  result := DataTable.Fields[idx_PagosClienteDC].AsString;
end;

procedure TPagosClienteDataTableRules.SetDCValue(const aValue: String);
begin
  DataTable.Fields[idx_PagosClienteDC].AsString := aValue;
end;

function TPagosClienteDataTableRules.GetCUENTAValue: String;
begin
  result := DataTable.Fields[idx_PagosClienteCUENTA].AsString;
end;

procedure TPagosClienteDataTableRules.SetCUENTAValue(const aValue: String);
begin
  DataTable.Fields[idx_PagosClienteCUENTA].AsString := aValue;
end;

function TPagosClienteDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_PagosClienteFECHA_ALTA].AsDateTime;
end;

procedure TPagosClienteDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_PagosClienteFECHA_ALTA].AsDateTime := aValue;
end;

function TPagosClienteDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_PagosClienteFECHA_MODIFICACION].AsDateTime;
end;

procedure TPagosClienteDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_PagosClienteFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TPagosClienteDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_PagosClienteUSUARIO].AsString;
end;

procedure TPagosClienteDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_PagosClienteUSUARIO].AsString := aValue;
end;


{ TRecibosCompensadosCliDataTableRules }
constructor TRecibosCompensadosCliDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TRecibosCompensadosCliDataTableRules.Destroy;
begin
  inherited;
end;

function TRecibosCompensadosCliDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliID].AsInteger;
end;

procedure TRecibosCompensadosCliDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosCompensadosCliID].AsInteger := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetID_RECIBO_COMPENSADOValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliID_RECIBO_COMPENSADO].AsInteger;
end;

procedure TRecibosCompensadosCliDataTableRules.SetID_RECIBO_COMPENSADOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosCompensadosCliID_RECIBO_COMPENSADO].AsInteger := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliREFERENCIA].AsString;
end;

procedure TRecibosCompensadosCliDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCompensadosCliREFERENCIA].AsString := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliSITUACION].AsString;
end;

procedure TRecibosCompensadosCliDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCompensadosCliSITUACION].AsString := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliID_FACTURA].AsInteger;
end;

procedure TRecibosCompensadosCliDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosCompensadosCliID_FACTURA].AsInteger := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetFECHA_EMISIONValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliFECHA_EMISION].AsDateTime;
end;

procedure TRecibosCompensadosCliDataTableRules.SetFECHA_EMISIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosCompensadosCliFECHA_EMISION].AsDateTime := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetFECHA_VENCIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliFECHA_VENCIMIENTO].AsDateTime;
end;

procedure TRecibosCompensadosCliDataTableRules.SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosCompensadosCliFECHA_VENCIMIENTO].AsDateTime := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetIMPORTEValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliIMPORTE].AsCurrency;
end;

procedure TRecibosCompensadosCliDataTableRules.SetIMPORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosCompensadosCliIMPORTE].AsCurrency := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetOTROS_GASTOSValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliOTROS_GASTOS].AsCurrency;
end;

procedure TRecibosCompensadosCliDataTableRules.SetOTROS_GASTOSValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosCompensadosCliOTROS_GASTOS].AsCurrency := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliIMPORTE_TOTAL].AsCurrency;
end;

procedure TRecibosCompensadosCliDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosCompensadosCliIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliFECHA_FACTURA].AsDateTime;
end;

procedure TRecibosCompensadosCliDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_RecibosCompensadosCliFECHA_FACTURA].AsDateTime := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetIMPORTE_FACTURAValue: Currency;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliIMPORTE_FACTURA].AsCurrency;
end;

procedure TRecibosCompensadosCliDataTableRules.SetIMPORTE_FACTURAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_RecibosCompensadosCliIMPORTE_FACTURA].AsCurrency := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliID_CLIENTE].AsInteger;
end;

procedure TRecibosCompensadosCliDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosCompensadosCliID_CLIENTE].AsInteger := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetNOMBRE_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliNOMBRE_CLIENTE].AsString;
end;

procedure TRecibosCompensadosCliDataTableRules.SetNOMBRE_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCompensadosCliNOMBRE_CLIENTE].AsString := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetNIF_CIF_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliNIF_CIF_CLIENTE].AsString;
end;

procedure TRecibosCompensadosCliDataTableRules.SetNIF_CIF_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_RecibosCompensadosCliNIF_CIF_CLIENTE].AsString := aValue;
end;

function TRecibosCompensadosCliDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_RecibosCompensadosCliID_EMPRESA].AsInteger;
end;

procedure TRecibosCompensadosCliDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_RecibosCompensadosCliID_EMPRESA].AsInteger := aValue;
end;


initialization
  RegisterDataTableRules(RID_RecibosCliente, TRecibosClienteDataTableRules);
  RegisterDataTableRules(RID_RecibosCliente_Refresh, TRecibosCliente_RefreshDataTableRules);
  RegisterDataTableRules(RID_PagosCliente, TPagosClienteDataTableRules);
  RegisterDataTableRules(RID_RecibosCompensadosCli, TRecibosCompensadosCliDataTableRules);

end.
